Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## net.sf.saxon.expr.instruct
Class Choose

    java.lang.Object
      net.sf.saxon.expr.Expression
          net.sf.saxon.expr.instruct.Instruction
              net.sf.saxon.expr.instruct.Choose

All Implemented Interfaces:
  Serializable, SourceLocator, LocationProvider, SaxonLocator, TailCallReturner, InstructionInfo, Locator

    public class Choose

extends Instruction

Compiled representation of an xsl:choose or xsl:if element in the stylesheet. Also used for typeswitch in XQuery.

See Also:
  Serialized Form

Field Summary

Fields inherited from class net.sf.saxon.expr.Expression
`EFFECTIVE_BOOLEAN_VALUE, EVALUATE_METHOD, EVENT_FEED_METHOD, ITEM_FEED_METHOD, ITERATE_METHOD, locationId, MAX_SEQUENCE_LENGTH, MAX_STRING_LENGTH, PROCESS_METHOD, PUSH_SELECTION, staticProperties, UNBOUNDED_LOWER, UNBOUNDED_UPPER, WATCH_METHOD`

Constructor Summary
`Choose(Expression[] conditions, Expression[] actions)` Construct an xsl:choose instruction

Method Summary
`PathMap.PathMapNodeSet` | `addToPathMap(PathMap pathMap, PathMap.PathMapNodeSet pathMapNodeSet)` Add a representation of this expression to a PathMap.
`void` | `checkForUpdatingSubexpressions()` Check to ensure that this expression does not contain any updating subexpressions.
`void` | `checkPermittedContents(SchemaType parentType, StaticContext env, boolean whole)` Check that any elements and attributes constructed or returned by this expression are acceptable in the content model of a given complex type.
`int` | `computeCardinality()` Compute the cardinality of the sequence returned by evaluating this instruction
`int` | `computeSpecialProperties()` Get the static properties of this expression (other than its type).
`Expression` | `copy()` Copy an expression.
`boolean` | `createsNewNodes()` Determine whether this instruction creates new nodes.
`Item` | `evaluateItem(XPathContext context)` Evaluate an expression as a single item.
`void` | `evaluatePendingUpdates(XPathContext context, PendingUpdateList pul)` Evaluate an updating expression, adding the results to a Pending Update List.
`void` | `explain(ExpressionPresenter out)` Diagnostic print of expression structure.
`Expression[]` | `getActions()` Get the array of actions to be performed
`Expression[]` | `getConditions()` Get the array of conditions to be tested
`int` | `getImplementationMethod()` An implementation of Expression must provide at least one of the methods evaluateItem(), iterate(), or process().
`int` | `getInstructionNameCode()` Get the name of this instruction for diagnostic and tracing purposes We assume that if there was only one condition then it was an xsl:if; this is not necessarily so, but it's adequate for tracing purposes.
`ItemType` | `getItemType(TypeHierarchy th)` Get the item type of the items returned by evaluating this instruction
`boolean` | `implementsStaticTypeCheck()` Determine whether this expression implements its own method for static type checking
`static boolean` | `isSingleBranchChoice(Expression exp)` Test whether an expression is a single-branch choose, that is, an expression of the form if (condition) then exp else ()
`boolean` | `isUpdatingExpression()` Determine whether this is an updating expression as defined in the XQuery update specification
`boolean` | `isVacuousExpression()` Determine whether this is a vacuous expression as defined in the XQuery update specification
`SequenceIterator<? extends Item>` | `iterate(XPathContext context)` Return an Iterator to iterate over the values of a sequence.
`EventIterator` | `iterateEvents(XPathContext context)` Deliver the result of the expression as a sequence of events.
`Iterator<Expression>` | `iterateSubExpressions()` Get all the XPath expressions associated with this instruction (in XSLT terms, the expression present on attributes of the instruction, as distinct from the child instructions in a sequence construction)
`static Expression` | `makeConditional(Expression condition, Expression thenExp)` Make a simple conditional expression (if (condition) then (thenExp) else ()
`static Expression` | `makeConditional(Expression condition, Expression thenExp, Expression elseExp)` Make a simple conditional expression (if (condition) then (thenExp) else (elseExp)
`int` | `markTailFunctionCalls(StructuredQName qName, int arity)` Mark tail-recursive calls on functions.
`Expression` | `optimize(ExpressionVisitor visitor, ExpressionVisitor.ContextItemType contextItemType)` Perform optimisation of an expression and its subexpressions.
`TailCall` | `processLeavingTail(XPathContext context)` Process this instruction, that is, choose an xsl:when or xsl:otherwise child and process it.
`protected void` | `promoteInst(PromotionOffer offer)` Handle promotion offers, that is, non-local tree rewrites.
`boolean` | `replaceSubExpression(Expression original, Expression replacement)` Replace one subexpression by a replacement subexpression
`Expression` | `simplify(ExpressionVisitor visitor)` Simplify an expression.
`Expression` | `staticTypeCheck(SequenceType req, boolean backwardsCompatible, RoleLocator role, TypeCheckerEnvironment visitor)` Static type checking for conditional expressions is delegated to the expression itself, and is performed separately on each branch of the conditional, so that dynamic checks are added only on those branches where the check is actually required.
`String` | `toString()` The toString() method for an expression attempts to give a representation of the expression in an XPath-like form, but there is no guarantee that the syntax will actually be true XPath.
`Expression` | `typeCheck(ExpressionVisitor visitor, ExpressionVisitor.ContextItemType contextItemType)` Perform type checking of an expression and its subexpressions.

Methods inherited from class net.sf.saxon.expr.instruct.Instruction
`assembleParams, assembleTunnelParams, dynamicError, evaluateAsString, getConstructType, getExpressionName, getInstructionName, getIteratorFromProcessMethod, getSourceLocator, isXSLT, process, promote`

Methods inherited from class net.sf.saxon.expr.Expression
`adoptChildExpression, computeDependencies, computeStaticProperties, doPromotion, dynamicError, effectiveBooleanValue, explain, getCardinality, getColumnNumber, getColumnNumber, getContainer, getDependencies, getEvaluationMethod, getExecutable, getHostLanguage, getIntegerBounds, getIntrinsicDependencies, getLineNumber, getLineNumber, getLocationId, getLocationProvider, getObjectName, getProperties, getProperty, getPublicId, getSlotsUsed, getSpecialProperties, getSystemId, getSystemId, hasLoopingSubexpression, hasVariableBinding, isSubtreeExpression, iterateSameFocusSubExpressions, resetLocalStaticProperties, setContainer, setEvaluationMethod, setFiltered, setFlattened, setLocationId, suppressValidation, typeError`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Methods inherited from interface javax.xml.transform.SourceLocator
`getColumnNumber, getLineNumber, getPublicId, getSystemId`

Constructor Detail

### Choose

    public Choose(Expression[] conditions,
                  Expression[] actions)

  Construct an xsl:choose instruction

  Parameters:
    `conditions` - the conditions to be tested, in order
    `actions` - the actions to be taken when the corresponding condition is true

Method Detail

### makeConditional

    public static Expression makeConditional(Expression condition,
                                             Expression thenExp,
                                             Expression elseExp)

  Make a simple conditional expression (if (condition) then (thenExp) else (elseExp)

  Parameters:
    `condition` - the condition to be tested
    `thenExp` - the expression to be evaluated if the condition is true
    `elseExp` - the expression to be evaluated if the condition is false
  Returns:
    the expression

### makeConditional

    public static Expression makeConditional(Expression condition,
                                             Expression thenExp)

  Make a simple conditional expression (if (condition) then (thenExp) else ()

  Parameters:
    `condition` - the condition to be tested
    `thenExp` - the expression to be evaluated if the condition is true
  Returns:
    the expression

### isSingleBranchChoice

    public static boolean isSingleBranchChoice(Expression exp)

  Test whether an expression is a single-branch choose, that is, an expression of the form if (condition) then exp else ()

  Parameters:
    `exp` - the expression to be tested
  Returns:
    true if the expression is a choose expression and there is only one condition, so that the expression returns () if this condition is false

### getConditions

    public Expression[] getConditions()

  Get the array of conditions to be tested

  Returns:
    the array of condition expressions

### getActions

    public Expression[] getActions()

  Get the array of actions to be performed

  Returns:
    the array of expressions to be evaluated when the corresponding condition is true

### getInstructionNameCode

    public int getInstructionNameCode()

  Get the name of this instruction for diagnostic and tracing purposes We assume that if there was only one condition then it was an xsl:if; this is not necessarily so, but it's adequate for tracing purposes.

  Overrides:
    `getInstructionNameCode` in class `Instruction`
  Returns:
    a code identifying the instruction: typically but not always the fingerprint of a name in the XSLT namespace

### simplify

    public Expression simplify(ExpressionVisitor visitor)
                        throws XPathException

  Simplify an expression. This performs any static optimization (by rewriting the expression as a different expression).

  Specified by:
    `simplify` in class `Instruction`
  Parameters:
    `visitor` - expression visitor object
  Returns:
    the simplified expression
  Throws:
    `XPathException` - if an error is discovered during expression rewriting

### typeCheck

    public Expression typeCheck(ExpressionVisitor visitor,
                                ExpressionVisitor.ContextItemType contextItemType)
                         throws XPathException

  Description copied from class: `Expression`
  Perform type checking of an expression and its subexpressions. This is the second phase of static optimization.

  This checks statically that the operands of the expression have the correct type; if necessary it generates code to do run-time type checking or type conversion. A static type error is reported only if execution cannot possibly succeed, that is, if a run-time type error is inevitable. The call may return a modified form of the expression.

  This method is called after all references to functions and variables have been resolved to the declaration of the function or variable. However, the types of such functions and variables may not be accurately known if they have not been explicitly declared.

  If the implementation returns a value other than "this", then it is required to ensure that the location information in the returned expression have been set up correctly. It should not rely on the caller to do this, although for historical reasons many callers do so.

  Overrides:
    `typeCheck` in class `Expression`
  Parameters:
    `visitor` - an expression visitor
    `contextItemType` - the static type of "." at the point where this expression is invoked. The parameter is set to null if it is known statically that the context item will be undefined. If the type of the context item is not known statically, the argument is set to `Type.ITEM_TYPE`
  Returns:
    the original expression, rewritten to perform necessary run-time type checks, and to perform other type-related optimizations
  Throws:
    `XPathException` - if an error is discovered during this phase (typically a type error)

### implementsStaticTypeCheck

    public boolean implementsStaticTypeCheck()

  Determine whether this expression implements its own method for static type checking

  Overrides:
    `implementsStaticTypeCheck` in class `Expression`
  Returns:
    true - this expression has a non-trivial implementation of the staticTypeCheck() method

### staticTypeCheck

    public Expression staticTypeCheck(SequenceType req,
                                      boolean backwardsCompatible,
                                      RoleLocator role,
                                      TypeCheckerEnvironment visitor)
                               throws XPathException

  Static type checking for conditional expressions is delegated to the expression itself, and is performed separately on each branch of the conditional, so that dynamic checks are added only on those branches where the check is actually required. This also results in a static type error if any branch is incapable of delivering a value of the required type. One reason for this approach is to avoid doing dynamic type checking on a recursive function call as this prevents tail-call optimization being used.

  Overrides:
    `staticTypeCheck` in class `Expression`
  Parameters:
    `req` - the required type
    `backwardsCompatible` - true if backwards compatibility mode applies
    `role` - the role of the expression in relation to the required type
    `visitor` - an expression visitor
  Returns:
    the expression after type checking (perhaps augmented with dynamic type checking code)
  Throws:
    `XPathException` - if failures occur, for example if the static type of one branch of the conditional is incompatible with the required type

### optimize

    public Expression optimize(ExpressionVisitor visitor,
                               ExpressionVisitor.ContextItemType contextItemType)
                        throws XPathException

  Description copied from class: `Expression`
  Perform optimisation of an expression and its subexpressions. This is the third and final phase of static optimization.

  This method is called after all references to functions and variables have been resolved to the declaration of the function or variable, and after all type checking has been done.

  Overrides:
    `optimize` in class `Expression`
  Parameters:
    `visitor` - an expression visitor
    `contextItemType` - the static type of "." at the point where this expression is invoked. The parameter is set to null if it is known statically that the context item will be undefined. If the type of the context item is not known statically, the argument is set to `Type.ITEM_TYPE`
  Returns:
    the original expression, rewritten if appropriate to optimize execution
  Throws:
    `XPathException` - if an error is discovered during this phase (typically a type error)

### copy

    public Expression copy()

  Copy an expression. This makes a deep copy.

  Specified by:
    `copy` in class `Expression`
  Returns:
    the copy of the original expression

### checkForUpdatingSubexpressions

    public void checkForUpdatingSubexpressions()
                                        throws XPathException

  Check to ensure that this expression does not contain any updating subexpressions. This check is overridden for those expressions that permit updating subexpressions.

  Overrides:
    `checkForUpdatingSubexpressions` in class `Expression`
  Throws:
    `XPathException` - if the expression has a non-permitted updateing subexpression

### isUpdatingExpression

    public boolean isUpdatingExpression()

  Determine whether this is an updating expression as defined in the XQuery update specification

  Overrides:
    `isUpdatingExpression` in class `Expression`
  Returns:
    true if this is an updating expression

### isVacuousExpression

    public boolean isVacuousExpression()

  Determine whether this is a vacuous expression as defined in the XQuery update specification

  Overrides:
    `isVacuousExpression` in class `Expression`
  Returns:
    true if this expression is vacuous

### getImplementationMethod

    public int getImplementationMethod()

  An implementation of Expression must provide at least one of the methods evaluateItem(), iterate(), or process(). This method indicates which of these methods is prefered. For instructions this is the process() method.

  Overrides:
    `getImplementationMethod` in class `Instruction`
  Returns:
    the implementation method, for example `Expression.ITERATE_METHOD` or `Expression.EVALUATE_METHOD` or `Expression.PROCESS_METHOD`

### markTailFunctionCalls

    public int markTailFunctionCalls(StructuredQName qName,
                                     int arity)

  Mark tail-recursive calls on functions. For most expressions, this does nothing.

  Overrides:
    `markTailFunctionCalls` in class `Expression`
  Parameters:
    `qName` - the name of the function
    `arity` - the arity (number of parameters) of the function
  Returns:
    0 if no tail call was found; 1 if a tail call on a different function was found; 2 if a tail recursive call was found and if this call accounts for the whole of the value.

### getItemType

    public ItemType getItemType(TypeHierarchy th)

  Get the item type of the items returned by evaluating this instruction

  Overrides:
    `getItemType` in class `Instruction`
  Parameters:
    `th` - Type hierarchy cache
  Returns:
    the static item type of the instruction

### computeCardinality

    public int computeCardinality()

  Compute the cardinality of the sequence returned by evaluating this instruction

  Overrides:
    `computeCardinality` in class `Instruction`
  Returns:
    the static cardinality

### computeSpecialProperties

    public int computeSpecialProperties()

  Get the static properties of this expression (other than its type). The result is bit-signficant. These properties are used for optimizations. In general, if property bit is set, it is true, but if it is unset, the value is unknown.

  Overrides:
    `computeSpecialProperties` in class `Instruction`
  Returns:
    a set of flags indicating static properties of this expression

### createsNewNodes

    public final boolean createsNewNodes()

  Determine whether this instruction creates new nodes. This implementation returns true if any of the "actions" creates new nodes. (Nodes created by the conditions can't contribute to the result).

  Overrides:
    `createsNewNodes` in class `Instruction`
  Returns:
    true if the instruction creates new nodes (or if it can't be proved that it doesn't)

### iterateSubExpressions

    public Iterator<Expression> iterateSubExpressions()

  Get all the XPath expressions associated with this instruction (in XSLT terms, the expression present on attributes of the instruction, as distinct from the child instructions in a sequence construction)

  Overrides:
    `iterateSubExpressions` in class `Expression`
  Returns:
    an iterator containing the sub-expressions of this expression

### replaceSubExpression

    public boolean replaceSubExpression(Expression original,
                                        Expression replacement)

  Replace one subexpression by a replacement subexpression

  Overrides:
    `replaceSubExpression` in class `Expression`
  Parameters:
    `original` - the original subexpression
    `replacement` - the replacement subexpression
  Returns:
    true if the original subexpression is found

### promoteInst

    protected void promoteInst(PromotionOffer offer)
                        throws XPathException

  Handle promotion offers, that is, non-local tree rewrites.

  Overrides:
    `promoteInst` in class `Instruction`
  Parameters:
    `offer` - The type of rewrite being offered
  Throws:
    `XPathException`

### checkPermittedContents

    public void checkPermittedContents(SchemaType parentType,
                                       StaticContext env,
                                       boolean whole)
                                throws XPathException

  Check that any elements and attributes constructed or returned by this expression are acceptable in the content model of a given complex type. It's always OK to say yes, since the check will be repeated at run-time. The process of checking element and attribute constructors against the content model of a complex type also registers the type of content expected of those constructors, so the static validation can continue recursively.

  Overrides:
    `checkPermittedContents` in class `Expression`
  Parameters:
    `parentType` - the "given complex type": the method is checking that the nodes returned by this expression are acceptable members of the content model of this type
    `env` - the static context
    `whole` - if true, we want to check that the value of this expression satisfies the content model as a whole; if false we want to check that the value of the expression is acceptable as one part of the content
  Throws:
    `XPathException` - if the value delivered by this expression cannot be part of the content model of the given type

### addToPathMap

    public PathMap.PathMapNodeSet addToPathMap(PathMap pathMap,
                                               PathMap.PathMapNodeSet pathMapNodeSet)

  Add a representation of this expression to a PathMap. The PathMap captures a map of the nodes visited by an expression in a source tree.

  The default implementation of this method assumes that an expression does no navigation other than the navigation done by evaluating its subexpressions, and that the subexpressions are evaluated in the same context as the containing expression. The method must be overridden for any expression where these assumptions do not hold. For example, implementations exist for AxisExpression, ParentExpression, and RootExpression (because they perform navigation), and for the doc(), document(), and collection() functions because they create a new navigation root. Implementations also exist for PathExpression and FilterExpression because they have subexpressions that are evaluated in a different context from the calling expression.

  Overrides:
    `addToPathMap` in class `Expression`
  Parameters:
    `pathMap` - the PathMap to which the expression should be added
    `pathMapNodeSet` - the set of PathMap nodes to which the paths from this expression should be appended
  Returns:
    the pathMapNode representing the focus established by this expression, in the case where this expression is the first operand of a path expression or filter expression. For an expression that does navigation, it represents the end of the arc in the path map that describes the navigation route. For other expressions, it is the same as the input pathMapNode.

### toString

    public String toString()

  The toString() method for an expression attempts to give a representation of the expression in an XPath-like form, but there is no guarantee that the syntax will actually be true XPath. In the case of XSLT instructions, the toString() method gives an abstracted view of the syntax

  Overrides:
    `toString` in class `Expression`
  Returns:
    a representation of the expression as a string

### explain

    public void explain(ExpressionPresenter out)

  Diagnostic print of expression structure. The abstract expression tree is written to the supplied output destination.

  Specified by:
    `explain` in class `Expression`
  Parameters:
    `out` - the expression presenter used to display the structure

### processLeavingTail

    public TailCall processLeavingTail(XPathContext context)
                                throws XPathException

  Process this instruction, that is, choose an xsl:when or xsl:otherwise child and process it.

  Specified by:
    `processLeavingTail` in interface `TailCallReturner`
  Specified by:
    `processLeavingTail` in class `Instruction`
  Parameters:
    `context` - the dynamic context of this transformation
  Returns:
    a TailCall, if the chosen branch ends with a call of call-template or apply-templates. It is the caller's responsibility to execute such a TailCall. If there is no TailCall, returns null.
  Throws:
    `XPathException` - if any non-recoverable dynamic error occurs

### evaluateItem

    public Item evaluateItem(XPathContext context)
                      throws XPathException

  Evaluate an expression as a single item. This always returns either a single Item or null (denoting the empty sequence). No conversion is done. This method should not be used unless the static type of the expression is a subtype of "item" or "item?": that is, it should not be called if the expression may return a sequence. There is no guarantee that this condition will be detected.

  Overrides:
    `evaluateItem` in class `Instruction`
  Parameters:
    `context` - The context in which the expression is to be evaluated
  Returns:
    the node or atomic value that results from evaluating the expression; or null to indicate that the result is an empty sequence
  Throws:
    `XPathException` - if any dynamic error occurs evaluating the expression

### iterate

    public SequenceIterator<? extends Item> iterate(XPathContext context)
                                             throws XPathException

  Return an Iterator to iterate over the values of a sequence. The value of every expression can be regarded as a sequence, so this method is supported for all expressions. This default implementation relies on the process() method: it "pushes" the results of the instruction to a sequence in memory, and then iterates over this in-memory sequence. In principle instructions should implement a pipelined iterate() method that avoids the overhead of intermediate storage.

  Overrides:
    `iterate` in class `Instruction`
  Parameters:
    `context` - supplies the context for evaluation
  Returns:
    a SequenceIterator that can be used to iterate over the result of the expression
  Throws:
    `XPathException` - if any dynamic error occurs evaluating the expression

### iterateEvents

    public EventIterator iterateEvents(XPathContext context)
                                throws XPathException

  Deliver the result of the expression as a sequence of events.

  The events (of class `PullEvent`) are either complete items, or one of startElement, endElement, startDocument, or endDocument, known as semi-nodes. The stream of events may also include a nested EventIterator. If a start-end pair exists in the sequence, then the events between this pair represent the content of the document or element. The content sequence will have been processed to the extent that any attribute and namespace nodes in the content sequence will have been merged into the startElement event. Namespace fixup will have been performed: that is, unique prefixes will have been allocated to element and attribute nodes, and all namespaces will be declared by means of a namespace node in the startElement event or in an outer startElement forming part of the sequence. However, duplicate namespaces may appear in the sequence.

  The content of an element or document may include adjacent or zero-length text nodes, atomic values, and nodes represented as nodes rather than broken down into events.

  Overrides:
    `iterateEvents` in class `Expression`
  Parameters:
    `context` - The dynamic evaluation context
  Returns:
    the result of the expression as an iterator over a sequence of PullEvent objects
  Throws:
    `XPathException` - if a dynamic error occurs during expression evaluation

### evaluatePendingUpdates

    public void evaluatePendingUpdates(XPathContext context,
                                       PendingUpdateList pul)
                                throws XPathException

  Evaluate an updating expression, adding the results to a Pending Update List. The default implementation of this method, which is used for non-updating expressions, throws an UnsupportedOperationException

  Overrides:
    `evaluatePendingUpdates` in class `Expression`
  Parameters:
    `context` - the XPath dynamic evaluation context
    `pul` - the pending update list to which the results should be written
  Throws:
    `XPathException` - if evaluation fails

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright (c) 2004-2011 Saxonica Limited. All rights reserved.